#!/bin/bash
LANG=en_US.utf8
LC_ALL=en_US.utf8
unameout="$(uname -s)"

mn=`date +"%b"`
yr=`date +"%Y"`
let nyr=$yr+1


for ld in {1..3}; do

if [ $ld = 1 ]; then

if [ $mn == "Jan" ]; then prd='FMA'; yrr=$yr ; fi
if [ $mn == "Feb" ]; then prd='MAM'; yrr=$yr ; fi
if [ $mn == "Mar" ]; then prd='AMJ'; yrr=$yr ; fi
if [ $mn == "Apr" ]; then prd='MJJ'; yrr=$yr ; fi
if [ $mn == "May" ]; then prd='JJA'; yrr=$yr ; fi
if [ $mn == "Jun" ]; then prd='JAS'; yrr=$yr ; fi
if [ $mn == "Jul" ]; then prd='ASO'; yrr=$yr ; fi
if [ $mn == "Aug" ]; then prd='SON'; yrr=$yr ; fi
if [ $mn == "Sep" ]; then prd='OND'; yrr=$yr ; fi
if [ $mn == "Oct" ]; then prd='NDJ'; yrr=$yr/$nyr ; fi
if [ $mn == "Nov" ]; then prd='DJF'; yrr=$yr/$nyr ; fi
if [ $mn == "Dec" ]; then prd='JFM'; yrr=$nyr ; fi
fi

if [ $ld = 2 ]; then

if [ $mn == "Jan" ]; then prd='MAM'; yrr=$yr ; fi
if [ $mn == "Feb" ]; then prd='AMJ'; yrr=$yr ; fi
if [ $mn == "Mar" ]; then prd='MJJ'; yrr=$yr ; fi
if [ $mn == "Apr" ]; then prd='JJA'; yrr=$yr ; fi
if [ $mn == "May" ]; then prd='JAS'; yrr=$yr ; fi
if [ $mn == "Jun" ]; then prd='ASO'; yrr=$yr ; fi
if [ $mn == "Jul" ]; then prd='SON'; yrr=$yr ; fi
if [ $mn == "Aug" ]; then prd='OND'; yrr=$yr ; fi
if [ $mn == "Sep" ]; then prd='NDJ'; yrr=$yr/$nyr ; fi
if [ $mn == "Oct" ]; then prd='DJF'; yrr=$yr/$nyr ; fi
if [ $mn == "Nov" ]; then prd='JFM'; yrr=$nyr ; fi
if [ $mn == "Dec" ]; then prd='FMA'; yrr=$nyr ; fi
fi

if [ $ld = 3 ]; then

if [ $mn == "Jan" ]; then prd='AMJ'; yrr=$yr ; fi
if [ $mn == "Feb" ]; then prd='MJJ'; yrr=$yr ; fi
if [ $mn == "Mar" ]; then prd='JJA'; yrr=$yr ; fi
if [ $mn == "Apr" ]; then prd='JAS'; yrr=$yr ; fi
if [ $mn == "May" ]; then prd='ASO'; yrr=$yr ; fi
if [ $mn == "Jun" ]; then prd='SON'; yrr=$yr ; fi
if [ $mn == "Jul" ]; then prd='OND'; yrr=$yr ; fi
if [ $mn == "Aug" ]; then prd='NDJ'; yrr=$yr/$nyr ; fi
if [ $mn == "Sep" ]; then prd='DJF'; yrr=$yr/$nyr ; fi
if [ $mn == "Oct" ]; then prd='JFM'; yrr=$nyr ; fi
if [ $mn == "Nov" ]; then prd='FMA'; yrr=$nyr ; fi
if [ $mn == "Dec" ]; then prd='MAM'; yrr=$nyr ; fi
fi

rm train_data/nmme_hind_sst_ld${ld}.nc
rm train_data/nmme_fcst_sst_ld${ld}.nc


wget --no-check-certificate https://ftp.cpc.ncep.noaa.gov/International/PREPARE_africa/seasonal/data/$mn/nmme_hind_sst_ld${ld}.nc
wget --no-check-certificate https://ftp.cpc.ncep.noaa.gov/International/PREPARE_africa/seasonal/data/$mn/nmme_fcst_sst_ld${ld}.nc

mv nmme_hind_sst_ld${ld}.nc train_data/
mv nmme_fcst_sst_ld${ld}.nc train_data/


cat>gen_cca_nmme_sst.py<<eofPY
#!/usr/bin/env python
# coding: utf-8

import xcast as xc 
import xarray as xr 
import cartopy.crs as ccrs 
import numpy as np
import matplotlib.pyplot as plt
#import rioxarray
#import geopandas as gpd
from shapely.geometry import mapping

wlon1=$W
elon1=$E
slat1=$S
nlat1=$N

wlon=$1
elon=$2
slat=$3
nlat=$4

wl=$W
el=$E
sl=$S
nl=$N


longrid = np.arange(wlon, elon + 10,10)
latgrid = np.arange(slat, nlat + 10,10)

longridl = longrid.tolist()
latgridl = latgrid.tolist()


model1 = xr.open_dataset('train_data//nmme_hind_sst_ld${ld}.nc')
obs1 = xr.open_dataset('train_data/chirps_hind_precip_ld${ld}.nc')
fmodel1 = xr.open_dataset('train_data/nmme_fcst_sst_ld${ld}.nc')

model = model1.sst.expand_dims({'M':[0]})
fmodel = fmodel1.sst.expand_dims({'M':[0]})
obs = obs1.precip.expand_dims({'M':[0]})

drymask = xc.drymask(obs, dry_threshold=0.1, quantile_threshold=0.3)
obs = obs * drymask

model = model.sel(lon=slice(wl, el), lat=slice(sl, nl))
fmodel = fmodel.sel(lon=slice(wl, el), lat=slice(sl, nl))
obs = obs.sel(lon=slice(wlon, elon), lat=slice(slat, nlat))

mask_missing = model.mean('time', skipna=False).mean('M', skipna=False)
mask_missing = xr.ones_like(mask_missing).where(~np.isnan(mask_missing), other=np.nan )
model = model * mask_missing

#model = xc.regrid(model, obs.lon, obs.lat)
#fmodel = xc.regrid(fmodel, obs.lon, obs.lat)

hindcasts_prob = []
i=1
for xtrain, ytrain, xtest, ytest in xc.CrossValidator(model, obs, window=5):
    print("window {}".format(i))
    i += 1
    reg = xc.CCA(search_override=(5,5,3))
    reg.fit(xtrain, ytrain)
    probs =  reg.predict_proba(xtest)
    hindcasts_prob.append(probs.isel(time=2))
hindcasts_prob = xr.concat(hindcasts_prob, 'time')

hindcasts_prob = xc.gaussian_smooth(hindcasts_prob, kernel=5)
obs = xc.gaussian_smooth(obs, kernel=5)

ohc = xc.OneHotEncoder() 
ohc.fit(obs)
T = ohc.transform(obs)
clim = xr.ones_like(T) * 0.333


xccaloadings = reg.x_cca_loadings*-1
yccaloadings = reg.y_cca_loadings*-1
xccascores   = reg.x_cca_scores*-1
yccascores   = reg.y_cca_scores*-1
corr = reg.canonical_correlations

for md in range(3):
    mdd = md + 1
    avcorr = corr.sel(mode=mdd).values
    avcorr = np.round(avcorr,2)

    fig, ax = plt.subplots()
    ax.set_ylabel('Score')
    ax.set_xlabel('Time')
    t= ax.set_xticks(ticks=range(25), labels=[str(i) for i in range(1993, 2018) ], rotation=90)
    plt.plot(xccascores[:,md],'b',label='X_CCA Score')
    plt.plot(yccascores[:,md],'r',label='Y_CCA Score')
    plt.legend()
    plt.title('Time Series of CCA Score, Lead-${ld}, Mode-'+str(mdd)+', Average Correlation: '+ str(avcorr))
    plt.savefig('fig_dir/nmme_tseries_sst_ld${ld}_md_'+str(mdd)+'.png')
    xc.view(xccaloadings[md,:,:,0], ocean=False, title='X-CCA Loadings, lead-${ld}, Mode-'+str(mdd)+', CCA, NMME Predicted SST, Valid: ${prd}', cmap=plt.get_cmap('RdBu_r',20),vmin=-5,vmax=5, savefig='fig_dir/nmme_xloadings_sst_ld${ld}_md_'+str(mdd)+'.png')

    xc.view(yccaloadings[md,:,:,0], ocean=False, title='Y-CCA Loadings, lead-${ld}, Mode-'+str(mdd)+', CCA, NMME Predicted SST, Valid: ${prd}', cmap=plt.get_cmap('RdBu_r',20),vmin=-5,vmax=5, savefig='fig_dir/nmme_yloadings_sst_ld${ld}_md_'+str(mdd)+'.png')



fprobs =  reg.predict_proba(fmodel)

import matplotlib.ticker as mticker
from cartopy.mpl.gridliner import LONGITUDE_FORMATTER, LATITUDE_FORMATTER

import sys
sys.path.append('./libs')

from prob import pview_probabilistic
ax = pview_probabilistic(fprobs.isel(time=0), ocean=False, title='Precip Forecast, using NMME Predicted SST ld${ld}, CCA, Valid: ${prd} ${yrr}')
gl = ax.gridlines(crs=ccrs.PlateCarree(), linewidth=1, color='blue', alpha=0.5, linestyle='--', draw_labels=True)
gl.top_labels = False
gl.left_labels = False
gl.right_labels=True
gl.xlines = True
gl.xlocator = mticker.FixedLocator(longridl)
gl.ylocator = mticker.FixedLocator(latgridl)
gl.xformatter = LONGITUDE_FORMATTER
gl.yformatter = LATITUDE_FORMATTER
gl.xlabel_style = {'color': 'black'}
gl.top_labels = False
gl.left_labels = True
gl.right_labels=False
gl.bottom_labels=True
plt.savefig('fig_dir/nmme_lead_${ld}_sst_gtropics_cca.png', dpi=300)

from pgrocsview import rview
groc = xc.GROCS(hindcasts_prob, T)
ax = rview(groc, ocean=False, title='NMME Predicted SST ld${ld}, CCA-GROCS, Valid: ${prd}')
gl = ax.gridlines(crs=ccrs.PlateCarree(), linewidth=2, color='black', alpha=0.5, linestyle='--', draw_labels=True)
gl.xlocator = mticker.FixedLocator(longridl)
gl.ylocator = mticker.FixedLocator(latgridl)
gl.xformatter = LONGITUDE_FORMATTER
gl.yformatter = LATITUDE_FORMATTER
gl.xlabel_style = {'color': 'black'}
gl.top_labels = False
gl.left_labels = True
gl.right_labels=False
gl.bottom_labels=True
gl.xlines = True
plt.savefig('fig_dir/nmme_lead_${ld}_sst_gtropics_cca_groc.png')


from rocc import view_mroc
ds = hindcasts_prob.assign_coords(M=(['BN', 'NN', 'AN']))
view_mroc(ds, T, savefig='fig_dir/nmme_lead_${ld}_sst_gtropics_cca_roc.png')

xc.view_reliability(hindcasts_prob, T)
plt.savefig('fig_dir/nmme_lead_${ld}_sst_gtropics_cca_relib.png', dpi=100)

#import os
#fr = fprobs.assign_coords(M=([0, 1, 2]))
#frr = fr.transpose("lat", "lon", "time", "M")
#ttt = frr.rename("prob")
#ttt.to_netcdf('./nmme_week${ld}_cca.nc')

#ttt = rpss.rename("skill")
#ttt.to_netcdf('./nmme_week${ld}_sst_gtropics_cca_rpss.nc')

#ttt = groc.rename("skill")
#ttt.to_netcdf('./nmme_week${ld}_sst_gtropics_cca_groc.nc')
eofPY

python gen_cca_nmme_sst.py

convert -trim fig_dir/nmme_lead_${ld}_sst_gtropics_cca.png fig_dir/nmme_lead_${ld}_sst_gtropics_cca.png
convert -trim fig_dir/nmme_lead_${ld}_sst_gtropics_cca_groc.png fig_dir/nmme_lead_${ld}_sst_gtropics_cca_groc.png
convert -trim fig_dir/nmme_lead_${ld}_sst_gtropics_cca_relib.png fig_dir/nmme_lead_${ld}_sst_gtropics_cca_relib.png

convert -bordercolor white -border 10 fig_dir/nmme_lead_${ld}_sst_gtropics_cca.png fig_dir/nmme_lead_${ld}_sst_gtropics_cca.png
convert -bordercolor white -border 10 fig_dir/nmme_lead_${ld}_sst_gtropics_cca_groc.png fig_dir/nmme_lead_${ld}_sst_gtropics_cca_groc.png
convert -bordercolor white -border 10 fig_dir/nmme_lead_${ld}_sst_gtropics_cca_relib.png fig_dir/nmme_lead_${ld}_sst_gtropics_cca_relib.png

for md in {1..3}; do

convert -trim fig_dir/nmme_xloadings_sst_ld${ld}_md_${md}.png fig_dir/nmme_xloadings_sst_ld${ld}_md_${md}.png
convert -trim fig_dir/nmme_yloadings_sst_ld${ld}_md_${md}.png fig_dir/nmme_yloadings_sst_ld${ld}_md_${md}.png
convert -trim fig_dir/nmme_tseries_sst_ld${ld}_md_${md}.png fig_dir/nmme_tseries_sst_ld${ld}_md_${md}.png

convert -bordercolor white -border 10 fig_dir/nmme_xloadings_sst_ld${ld}_md_${md}.png fig_dir/nmme_xloadings_sst_ld${ld}_md_${md}.png
convert -bordercolor white -border 10 fig_dir/nmme_yloadings_sst_ld${ld}_md_${md}.png fig_dir/nmme_yloadings_sst_ld${ld}_md_${md}.png
convert -bordercolor white -border 10 fig_dir/nmme_tseries_sst_ld${ld}_md_${md}.png fig_dir/nmme_tseries_sst_ld${ld}_md_${md}.png

done
done
